using System;
using System.Text;
using System.IO;
using GrapeCity.ActiveReports.PageReportModel;
using GrapeCity.ActiveReports.Expressions;
using System.Xml;
using GrapeCity.ActiveReports.Design;

namespace GrapeCity.ActiveReports.Samples.CreateReport
{
    internal sealed class LayoutBuilder
    {

        // RDL
        public static void BuildRdlReportLayout(Design.Designer designer)
        {
            PageReport report = new PageReport();

            report.Report.Body.Height = "5cm";
            report.Report.Width = "20cm";   

            report.Load(new StringReader(report.ToRdlString()));

            //report = LayoutBuilder.AddDataSetDataSource(report);//Adding DataSources to the PageReport object
            report = LayoutBuilder.addDataSet(report);
            MemoryStream reportStream = LayoutBuilder.LoadReportToStream(report);//Loading the PageReport object to a stream
            reportStream.Position = 0;


            designer.LoadReport(XmlReader.Create(reportStream), DesignerReportType.Page);
        }

        public static PageReport addDataSet(PageReport report)
        {
            // create DataSource for the report
            DataSource dataSource = new DataSource();
            dataSource.Name = "DataSource1";
            dataSource.ConnectionProperties.DataProvider = "DATASET";
            dataSource.ConnectionProperties.ConnectString = "";

            //Create DataSet with specified query and load database fields to the DataSet
            DataSet dataSet = new DataSet();
            Query query = new Query();
            dataSet.Name = "DataSet1";
            query.DataSourceName = "DataSource1";
            query.CommandType = QueryCommandType.Text;
            query.CommandText = "";
            dataSet.Query = query;
            //ȡֶ
            Field field = new Field("ͻID", "TF_PSS_MF.ͻID", null);
                dataSet.Fields.Add(field);
              
            //create report definition with specified DataSet and DataSource
            report.Report.DataSources.Add(dataSource);
            report.Report.DataSets.Add(dataSet);
            return report;
         
        }
        // 򱨱
        public static void BuildSectionReportLayout(Design.Designer designer)
        {
            // հ򱨱
            string rpx = "<?xml version=\"1.0\" encoding=\"utf-8\"?>                            <ActiveReportsLayout Version=\"3.2\" PrintWidth=\"9360\" DocumentName=\"ActiveReports Document\" ScriptLang=\"C#\" MasterReport=\"0\">                              <StyleSheet>                                <Style Name=\"Normal\" Value=\"font-family: Arial; font-style: normal; text-decoration: none; font-weight: normal; font-size: 10pt; color: Black; text-align: left; vertical-align: top; ddo-char-set: 1\" />                                <Style Name=\"Heading1\" Value=\"font-family: Arial; font-size: 16pt; font-style: normal; font-weight: bold\" />                                <Style Name=\"Heading2\" Value=\"font-family: Times New Roman; font-size: 14pt; font-style: italic; font-weight: bold\" />                                <Style Name=\"Heading3\" Value=\"font-family: Arial; font-size: 13pt; font-style: normal; font-weight: bold\" />                              </StyleSheet>                              <Sections>                                <Section Type=\"PageHeader\" Name=\"PageHeader1\" Height=\"360\" BackColor=\"16777215\" />                                <Section Type=\"Detail\" Name=\"Detail1\" Height=\"2880\" BackColor=\"16777215\" />                                <Section Type=\"PageFooter\" Name=\"PageFooter1\" Height=\"360\" BackColor=\"16777215\" />                              </Sections>                              <ReportComponentTray />                              <PageSettings />                              <Parameters />                            </ActiveReportsLayout>";

            // 򱨱Դṹ
            System.Data.DataTable dt = new System.Data.DataTable();
            dt.Columns.Add("Col1");
            dt.Columns.Add("Col2");
            dt.Columns.Add("Col3");

            designer.Report = null;

            // 򱨱
            designer.LoadReport(XmlReader.Create(LayoutBuilder.CovertStringToStream(rpx)), DesignerReportType.Section);

            // 򱨱Դ
            SectionReport sr2 = designer.Report as SectionReport;
            sr2.DataSource = dt;
        }

        // ҳ汨
        public static void BuildPageReportLayout(Design.Designer designer)
        {
            PageReport report = new PageReport();
            report.Load(new StringReader(
              @"<Report xmlns=""http://schemas.microsoft.com/sqlserver/reporting/2005/01/reportdefinition"">
                <Body>
                    <Height>27.9cm</Height>
                    <ReportItems>
                        <FixedPage Name=""FixedPage1"">
                            <Pages>
                                <Page />
                            </Pages>
                        </FixedPage>
                    </ReportItems>
                </Body>
                <BottomMargin>2.5cm</BottomMargin>
                <LeftMargin>2.5cm</LeftMargin>
                <PageHeight>27.9cm</PageHeight>
                <PageWidth>21.6cm</PageWidth>
                <RightMargin>2.5cm</RightMargin>
                <TopMargin>2.5cm</TopMargin>
                <Width>21.6cm</Width>
                  </Report>"));

            report = LayoutBuilder.AddDataSetDataSource(report);//Adding DataSources to the PageReport object
            MemoryStream reportStream = LayoutBuilder.LoadReportToStream(report);//Loading the PageReport object to a stream
            reportStream.Position = 0;

            designer.LoadReport(XmlReader.Create(reportStream), DesignerReportType.Page);
        }

        // ҳRDLԴ
        public static PageReport AddDataSetDataSource(PageReport report)
        {
            // create DataSource for the report
            DataSource dataSource = new DataSource();
            dataSource.Name = "Reels Database";
            dataSource.ConnectionProperties.DataProvider = "DATASET";
            dataSource.ConnectionProperties.ConnectString = "";

            //Create DataSet with specified query and load database fields to the DataSet
            DataSet dataSet = new DataSet();
            Query query = new Query();
            dataSet.Name = "Sample DataSet";
            query.DataSourceName = "Reels Database";
            query.CommandType = QueryCommandType.Text;
            query.CommandText = "";
            dataSet.Query = query;
            String[] fieldsList = new String[] { "MoviedID", "Title", "YearReleased", "MPAA" };
            foreach (string fieldName in fieldsList)
            {
                Field field = new Field(fieldName, fieldName, null);
                dataSet.Fields.Add(field);
            }
            //create report definition with specified DataSet and DataSource
            report.Report.DataSources.Add(dataSource);
            report.Report.DataSets.Add(dataSet);
            return report;
        }

      

        //ҳRDLתΪStream
        public static MemoryStream LoadReportToStream(PageReport report)
        {
            string rpt = report.ToRdlString();

            byte[] data = Encoding.UTF8.GetBytes(rpt);
            MemoryStream stream = new MemoryStream(data);
            return stream;
        }

        public static MemoryStream CovertStringToStream(string str)
        {
            byte[] data = Encoding.UTF8.GetBytes(str);
            MemoryStream stream = new MemoryStream(data);
            return stream;
        }
    }
}
